#include <Object.h>
#include <AudioSubscriber.h>

class AToneGenerator : public BObject
{
public:
		AToneGenerator(float freq, float rate);
		
	virtual void 	Play(float freq, float duration);
	virtual float	NextSample(float freq, float rate, int changed);
		
protected:
	BAudioSubscriber	*fSubscriber;
	long	fSubscriberID;	
	long	fSampleRate;
	
	float	fTwoPiDivSampleRate;
	float	fY1;
	float	fY0;
	float	fA;
	float	fB;
	float	fArg;
	
private:

};